<template>
	<div class="mod-config">
		<el-form :inline="true" :model="dataForm" @keyup.enter.native="getDataList()">
			<el-form-item>
				<el-input v-model="dataForm.key" placeholder="设备名称/设备编码" clearable></el-input>
			</el-form-item>
			<el-form-item>
				<el-button @click="getDataList()">查询</el-button>
				<el-button v-if="$hasPermission('monitoring:equipmentplcconnect:save')" type="primary" @click="addOrUpdateHandle()">新增</el-button>
			</el-form-item>
		</el-form>

		<base-table :data="dataList" :table-head-configs="tableConfigs" :max-height="500" @operate-event="handleOperations" @refreshDataList="getDataList" />

		<el-pagination
			@size-change="sizeChangeHandle"
			@current-change="currentChangeHandle"
			:current-page="pageIndex"
			:page-sizes="[10, 20, 50, 100]"
			:page-size="pageSize"
			:total="totalPage"
			layout="total, sizes, prev, pager, next, jumper"
		>
		</el-pagination>
		<!-- 弹窗, 新增 / 修改 -->
		<add-or-update v-if="addOrUpdateVisible" ref="addOrUpdate" :configs="addOrUpdateConfigs" @refreshDataList="getDataList" @destory-dialog="addOrUpdateVisible = false" />
	</div>
</template>

<script>
import { calcMaxHeight } from '@/utils'
// import AddOrUpdate from './equipmentPlcConnect-add-or-update'
import AddOrUpdate from '@/components/base-dialog/addOrUpdate'
import BaseTable from '@/components/base-table'
import TableOperateComponent from '@/components/base-table/components/operationComponent'
// import TableTextComponent from '@/components/base-table/components/detailComponent'
import { dictFilter } from '@/utils/filters'
// import axios from '@/utils/request.js'

const tableConfigs = [
	{ type: 'index', name: '序号' },
	{ prop: 'lineName', name: '产线' },
	{ prop: 'sectionName', name: '工段' },
	{ prop: 'equName', name: '设备' },
	{ prop: 'equCode', name: '设备编码' },
	{ prop: 'plcCode', name: 'PLC编码' },
	{ prop: 'plcName', name: 'PLC名称' },
	{ prop: 'plcIp', name: 'PLC IP' },
	{ prop: 'operations', name: '操作', fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['edit', 'delete'] }
]

const UnitDictTypeId = '1557173812109242370'
const getUnitList = function() {
	const dl = JSON.parse(localStorage.getItem('dictList'))[UnitDictTypeId] || []
	return dl.map(item => ({ label: item.dictLabel, value: item.dictValue }))
}
const addOrUpdateConfigs = {
	type: 'dialog',
	infoUrl: '/monitoring/equipmentPlcConnect',
	fields: [
		{ name: 'equipmentId', label: '设备', required: true, type: 'select', options: [] },
		{ name: 'plcId', label: 'PLC名称', required: true, type: 'select', options: [] }
	],
	operations: [
		{ name: 'cancel', url: true, showAlways: true },
		{ name: 'save', url: '/monitoring/equipmentPlcConnect', permission: '', showOnEdit: false },
		{ name: 'update', url: '/monitoring/equipmentPlcConnect', permission: '', showOnEdit: true }
	],
	subtable: {
		title: 'PLC采集参数',
		url: '/monitoring/equipmentPlcParam',
		relatedField: 'plcConId',
		tableConfigs: [
			{ type: 'index', name: '序号' },
			// { prop: 'plcConId', name: 'plc连接表ID' },
			{ prop: 'paramCode', name: '参数编码', formField: true, rules: [{ required: true, message: '必填', trigger: 'blur' }] },
			{ prop: 'paramName', name: '参数名称', formField: true, rules: [{ required: true, message: '必填', trigger: 'blur' }] },
			{ prop: 'paramAddress', name: '参数地址', formField: true },
			{ prop: 'unitDictValue', name: '单位', filter: dictFilter(UnitDictTypeId), formField: true, formType: 'select', formOptions: getUnitList() },
			{ prop: 'minValue', name: '最小值', formField: true },
			{ prop: 'maxValue', name: '最大值', formField: true },
			{ prop: 'defaultValue', name: '参数设定标准值', formField: true },
			{ prop: 'description', name: '描述', formField: true },
			{
				prop: 'enabled',
				name: '启用状态',
				filter: val => ['停用', '启用'][+val],
				// filter: val => ({0:'停用', 1:'启用'}[+val]),
				rules: [{ required: true, message: '必填', trigger: 'blur' }],
				formField: true,
				formType: 'select',
				formOptions: [
					{ value: 0, label: '停用' },
					{ value: 1, label: '启用' }
				]
			},
			{ prop: 'remark', name: '备注', formField: true },
			// { prop: 'createTime', name: '添加时间' },
			{
				prop: 'collection',
				name: '是否采集',
				filter: val => ['不采集', '采集'][+val],
				rules: [{ required: true, message: '必填', trigger: 'blur' }],
				formField: true,
				formType: 'select',
				formOptions: [
					{ value: 0, label: '不采集' },
					{ value: 1, label: '采集' }
				]
			},
			// { prop: 'collectionCycle', name: '采集周期（s） 暂不使用' },
			// { prop: 'reportingCycle', name: '上报周期（s） 暂不使用' },
			// { prop: 'reportingMethod', name: '上报方式 暂不使用' },
			// { prop: 'reportingCode', name: '上报编码 暂不使用' },
			{ prop: 'operations', name: '操作', fixed: 'right', width: 180, subcomponent: TableOperateComponent, options: ['edit', 'delete'] }
		]
	}
}

export default {
	data() {
		return {
			addOrUpdateConfigs,
			calcMaxHeight,
			tableConfigs,
			dataForm: {
				key: ''
			},
			dataList: [],
			pageIndex: 1,
			pageSize: 10,
			totalPage: 0,
			dataListLoading: false,
			dataListSelections: [],
			addOrUpdateVisible: false
		}
	},
	components: {
		AddOrUpdate,
		BaseTable
	},
	activated() {
		this.getEqList()
		this.getPlcList()
		this.getDataList()
	},
	methods: {
		// 设备列表
		getEqList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipment/page'),
				method: 'get',
				params: this.$http.adornParams({
					// page: this.pageIndex,
					// limit: this.pageSize,
					// key: this.dataForm.key
				})
			}).then(({ data }) => {
				const eqConfig = this.addOrUpdateConfigs.fields.find(item => item.name === 'equipmentId')
				eqConfig.options = data.data?.list?.map(item => ({ value: item.id, label: item.name })) || []
			})
		},
		// plc 列表
		getPlcList() {
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentPlc/page'),
				method: 'get',
				params: this.$http.adornParams({
					// page: this.pageIndex,
					// limit: this.pageSize,
					// key: this.dataForm.key
				})
			}).then(({ data }) => {
				const plcConfig = this.addOrUpdateConfigs.fields.find(item => item.name === 'plcId')
				plcConfig.options = data.data?.list?.map(item => ({ value: item.id, label: item.name })) || []
			})
		},
		handleOperations({ type, data: id }) {
			switch (type) {
				case 'edit':
					return this.addOrUpdateHandle(id)
				case 'delete':
					return this.deleteHandle(id)
			}
		},
		// 获取数据列表
		getDataList() {
			this.dataListLoading = true
			this.$http({
				url: this.$http.adornUrl('/monitoring/equipmentPlcConnect/page'),
				method: 'get',
				params: this.$http.adornParams({
					page: this.pageIndex,
					limit: this.pageSize,
					key: this.dataForm.key
				})
			}).then(({ data }) => {
				if (data && data.code === 0) {
					this.dataList = data.data.list
					this.totalPage = data.data.total
				} else {
					this.dataList = []
					this.totalPage = 0
				}
				this.dataListLoading = false
			})
		},
		// 每页数
		sizeChangeHandle(val) {
			this.pageSize = val
			this.pageIndex = 1
			this.getDataList()
		},
		// 当前页
		currentChangeHandle(val) {
			this.pageIndex = val
			this.getDataList()
		},
		// 多选
		selectionChangeHandle(val) {
			this.dataListSelections = val
		},
		// 新增 / 修改
		addOrUpdateHandle(id) {
			this.addOrUpdateVisible = true
			this.$nextTick(() => {
				this.$refs.addOrUpdate.init(id)
			})
		},
		// 删除
		deleteHandle(id) {
			var ids = id
				? [id]
				: this.dataListSelections.map(item => {
						return item.id
				  })
			this.$confirm(`确定对[id=${ids.join(',')}]进行[${id ? '删除' : '批量删除'}]操作?`, '提示', {
				confirmButtonText: '确定',
				cancelButtonText: '取消',
				type: 'warning'
			}).then(() => {
				this.$http({
					url: this.$http.adornUrl('/monitoring/equipmentPlcConnect'),
					method: 'delete',
					data: this.$http.adornData(ids, false, 'raw')
				}).then(({ data }) => {
					if (data && data.code === 0) {
						this.$message({
							message: '操作成功',
							type: 'success',
							duration: 1500,
							onClose: () => {
								this.getDataList()
							}
						})
					} else {
						this.$message.error(data.msg)
					}
				})
			})
		}
	}
}
</script>
